<?php
namespace Quivers\Components;

use Shopware\Models\Order\Detail as OrderDetailModel;



class CustomEvent
{

    /**
     * Order repository. Declared for an fast access to the order repository.
     *
     * @var \Shopware\Models\Order\Repository
     */
    public static $repository;

     public function getRepository()
    {
        self::$repository = Shopware()->Models()->getRepository(OrderDetailModel::class);
        return self::$repository;
    }


    public function refundAction($id, array $payload)
    {
        $amountRefunded = 0;
        $quantity = 0;

        $detail = $this->getRepository()->find($id);
          if (!$detail) {
                throw new ApiException\NotFoundException("Detail By id $id not found");
            }
        $orderId = $detail->getOrder()->getId();

        foreach ($payload["attribute"] as $key => $value){
                $subStr = subStr($key, 0, 11);
                $taxSubStr = subStr($key, 0, 11);
                if (($subStr == "shippingfee") and (isset($value))){
                    $amountRefunded = $amountRefunded + $value;
                    $quantity = $payload["attribute"]["quantityshipped_". $key[12]];
                }
                if (($taxSubStr == "taxrefunded") and (isset($value))){
                    $amountRefunded = $amountRefunded + $value;
                    $quantity = $payload["attribute"]["quantityshipped_". $key[12]];
                }
         }
        if (isSet($payload["attribute"]["quantityReturned"])){
             $amountRefunded = $payload["attribute"]["amountRefunded"];
             $quantity = $payload["attribute"]["quantityReturned"];

        }
        elseif (isSet($payload["attribute"]["cancellationQuantity"])){
                 $amountRefunded = $payload["amountRefunded"];
             $quantity = $payload["attribute"]["cancellationQuantity"];
        }
        if (isset($amountRefunded)){
            Shopware()->Events()->notify(
                 'Quivers_Controller_Backend_refundAction',
                 [
                     'itemId'=> (int)$id,
                     'orderId'=> $orderId,
                     'amountRefunded'=> $amountRefunded,
                     'quantity'=> $quantity,
                 ]
             );
            }
    }
}