<?php

namespace Quivers\Subscriber;

use Enlight\Event\SubscriberInterface;
use Quivers\Components\TaxCalculator;
use Quivers\Components\ConfigProvider;
use Enlight_Controller_ActionEventArgs as ActionEventArgs;

class Frontend implements SubscriberInterface
{
    private $taxCalculator;
    private $configProvider;
    

    public function __construct(TaxCalculator $taxCalculator, ConfigProvider $configProvider)
    {
       $this->taxCalculator = $taxCalculator;
       $this->configProvider = $configProvider;
    }

    public static function getSubscribedEvents()
    {
        return [
          'Enlight_Controller_Action_PostDispatchSecure_Frontend_Checkout' => 'quiversTax'

        ];
    }



    public function quiversTax(ActionEventArgs $args)
    {
        $controller = $args->getSubject();
 
        $request = $controller->Request();

        $allowedActions = ['confirm', 'shippingPayment', 'saveShippingPayment', 'finish'];
        $action = $controller->Request()->getActionName();
        $view = $controller->View();

    
        if($request->getParam("error_name")){
            $view->assign('quiversErrorMessage', $request->getParam("error_name"));
            $view->assign('quiversErrorName', $request->getParam("error_message"));
        }
        
        if (!in_array($action, $allowedActions, true)) {
            return;
        }
        $this->configProvider->getconfig($args);
        $this->taxCalculator->quivers_tax($args);
    }
}
